diff --git a/tests/test_flask.py b/tests/test_flask.py
index 38cb7d7..264c9cb 100644
--- a/tests/test_flask.py
+++ b/tests/test_flask.py
@@ -26,12 +26,11 @@
 
  fedocal.model test script
 """
-from __future__ import print_function
+from __future__ import unicode_literals, absolute_import, print_function
 
 __requires__ = ['SQLAlchemy >= 0.7', 'jinja2 >= 2.4']
 import pkg_resources
 
-import flask
 import logging
 import unittest
 import sys
@@ -43,6 +42,9 @@ from datetime import datetime
 from datetime import time
 from datetime import timedelta
 
+import flask
+import six
+
 sys.path.insert(0, os.path.join(os.path.dirname(
     os.path.abspath(__file__)), '..'))
 
@@ -57,10 +59,12 @@ from tests import (Modeltests, FakeUser, flask10_only, user_set, TODAY,
 class Flasktests(Modeltests):
     """ Flask application tests. """
 
+    maxDiff = None
+
     def __setup_db(self):
         """ Add a calendar and some meetings so that we can play with
         something. """
-        from test_meeting import Meetingtests
+        from .test_meeting import Meetingtests
         meeting = Meetingtests('test_init_meeting')
         meeting.session = self.session
         meeting.test_init_meeting()
@@ -73,14 +77,12 @@ class Flasktests(Modeltests):
         :arg filename: A string
         :returns: A string
         """
-        f = open(
-            os.path.join(
-                os.path.dirname(__file__),
-                'sample_files/{}'.format(filename)
-            )
+        filename = os.path.join(
+            os.path.dirname(__file__),
+            'sample_files/{}'.format(filename)
         )
-        content = f.read()
-        f.close()
+        with open(filename) as stream:
+            content = stream.read()
         return content
 
     def wrap_content(self, content, replacements=[]):
@@ -112,8 +114,9 @@ class Flasktests(Modeltests):
         """ Test the index function. """
         output = self.app.get('/')
         self.assertEqual(output.status_code, 200)
+        output_text = output.get_data(as_text=True)
         self.assertTrue(
-            '<title>Home - Fedocal</title>' in output.data)
+            '<title>Home - Fedocal</title>', output_text)
 
     def test_index(self):
         """ Test the index function. """
@@ -121,11 +124,12 @@ class Flasktests(Modeltests):
 
         output = self.app.get('/')
         self.assertEqual(output.status_code, 200)
-        self.assertTrue(
-            '<title>Home - Fedocal</title>' in output.data)
-        self.assertTrue('href="/test_calendar/">' in output.data)
-        self.assertTrue('href="/test_calendar2/">' in output.data)
-        self.assertTrue('href="/test_calendar4/">' in output.data)
+        output_text = output.get_data(as_text=True)
+        self.assertIn(
+            '<title>Home - Fedocal</title>', output_text)
+        self.assertIn('href="/test_calendar/">', output_text)
+        self.assertIn('href="/test_calendar2/">', output_text)
+        self.assertIn('href="/test_calendar4/">', output_text)
 
     def test_calendar(self):
         """ Test the calendar function. """
@@ -136,31 +140,35 @@ class Flasktests(Modeltests):
 
         output = self.app.get('/test_calendar', follow_redirects=True)
         self.assertEqual(output.status_code, 200)
-        self.assertTrue(
-            '<title>test_calendar - Fedocal</title>' in output.data)
-        self.assertTrue(' <a href="/test_calendar/">' in output.data)
-        self.assertTrue(' <a href="/test_calendar2/">' in output.data)
-        self.assertTrue(' <a href="/test_calendar4/">' in output.data)
+        output_text = output.get_data(as_text=True)
+        self.assertIn(
+            '<title>test_calendar - Fedocal</title>', output_text)
+        self.assertIn(' <a href="/test_calendar/">', output_text)
+        self.assertIn(' <a href="/test_calendar2/">', output_text)
+        self.assertIn(' <a href="/test_calendar4/">', output_text)
 
         output = self.app.get('/test_calendar2/')
         self.assertEqual(output.status_code, 200)
-        self.assertTrue(
-            '<title>test_calendar2 - Fedocal</title>' in output.data)
-        self.assertTrue(' <a href="/test_calendar/">' in output.data)
-        self.assertTrue(' <a href="/test_calendar2/">' in output.data)
-        self.assertTrue(' <a href="/test_calendar4/">' in output.data)
+        output_text = output.get_data(as_text=True)
+        self.assertIn(
+            '<title>test_calendar2 - Fedocal</title>', output_text)
+        self.assertIn(' <a href="/test_calendar/">', output_text)
+        self.assertIn(' <a href="/test_calendar2/">', output_text)
+        self.assertIn(' <a href="/test_calendar4/">', output_text)
 
         output = self.app.get('/foorbar/', follow_redirects=True)
         self.assertEqual(output.status_code, 200)
-        self.assertTrue(
-            'class="errors">No calendar named foorbar could be found</'
-            in output.data)
+        output_text = output.get_data(as_text=True)
+        self.assertIn(
+            'class="errors">No calendar named foorbar could be found</',
+            output_text)
 
         output = self.app.get('/test_calendar2/?tzone=Europe/Paris',
                               follow_redirects=True)
         self.assertEqual(output.status_code, 200)
-        self.assertTrue(
-            '<title>test_calendar2 - Fedocal</title>' in output.data)
+        output_text = output.get_data(as_text=True)
+        self.assertIn(
+            '<title>test_calendar2 - Fedocal</title>', output_text)
 
     def test_location(self):
         """ Test the location calendar function. """
@@ -171,11 +179,12 @@ class Flasktests(Modeltests):
 
         output = self.app.get('/location/test/', follow_redirects=True)
         self.assertEqual(output.status_code, 200)
-        self.assertTrue(
-            '<title>test - Fedocal</title>' in output.data)
-        self.assertTrue(' <a href="/test_calendar/">' in output.data)
-        self.assertTrue(' <a href="/test_calendar2/">' in output.data)
-        self.assertTrue(' <a href="/test_calendar4/">' in output.data)
+        output_text = output.get_data(as_text=True)
+        self.assertIn(
+            '<title>test - Fedocal</title>', output_text)
+        self.assertIn(' <a href="/test_calendar/">', output_text)
+        self.assertIn(' <a href="/test_calendar2/">', output_text)
+        self.assertIn(' <a href="/test_calendar4/">', output_text)
 
     def test_calendar_fullday(self):
         """ Test the calendar_fullday function. """
@@ -186,11 +195,12 @@ class Flasktests(Modeltests):
             '/test_calendar/%s/%s/%s/' % (
                 today.year, today.month, today.day))
         self.assertEqual(output.status_code, 200)
-        self.assertTrue(
-            '<title>test_calendar - Fedocal</title>' in output.data)
-        self.assertTrue(' <a href="/test_calendar/">' in output.data)
-        self.assertTrue(' <a href="/test_calendar2/">' in output.data)
-        self.assertTrue(' <a href="/test_calendar4/">' in output.data)
+        output_text = output.get_data(as_text=True)
+        self.assertIn(
+            '<title>test_calendar - Fedocal</title>', output_text)
+        self.assertIn(' <a href="/test_calendar/">', output_text)
+        self.assertIn(' <a href="/test_calendar2/">', output_text)
+        self.assertIn(' <a href="/test_calendar4/">', output_text)
 
         output = self.app.get(
             '/test_calendar/%s/%s/%s' % (
@@ -200,11 +210,12 @@ class Flasktests(Modeltests):
         output = self.app.get('/test_calendar/%s/%s/%s/' % (
             today.year, today.month, today.day), follow_redirects=True)
         self.assertEqual(output.status_code, 200)
-        self.assertTrue(
-            '<title>test_calendar - Fedocal</title>' in output.data)
-        self.assertTrue(' <a href="/test_calendar/">' in output.data)
-        self.assertTrue(' <a href="/test_calendar2/">' in output.data)
-        self.assertTrue(' <a href="/test_calendar4/">' in output.data)
+        output_text = output.get_data(as_text=True)
+        self.assertIn(
+            '<title>test_calendar - Fedocal</title>', output_text)
+        self.assertIn(' <a href="/test_calendar/">', output_text)
+        self.assertIn(' <a href="/test_calendar2/">', output_text)
+        self.assertIn(' <a href="/test_calendar4/">', output_text)
 
     def test_calendar_list(self):
         """ Test the calendar_list function. """
@@ -212,27 +223,30 @@ class Flasktests(Modeltests):
 
         output = self.app.get('/list/test_calendar/')
         self.assertEqual(output.status_code, 200)
-        self.assertTrue(
-            '<title>test_calendar - Fedocal</title>' in output.data)
-        self.assertTrue(' <a href="/test_calendar/">' in output.data)
-        self.assertTrue(' <a href="/test_calendar2/">' in output.data)
-        self.assertTrue(' <a href="/test_calendar4/">' in output.data)
+        output_text = output.get_data(as_text=True)
+        self.assertIn(
+            '<title>test_calendar - Fedocal</title>', output_text)
+        self.assertIn(' <a href="/test_calendar/">', output_text)
+        self.assertIn(' <a href="/test_calendar2/">', output_text)
+        self.assertIn(' <a href="/test_calendar4/">', output_text)
 
         output = self.app.get('/list/foorbar/', follow_redirects=True)
         self.assertEqual(output.status_code, 200)
-        self.assertTrue(
-            'class="errors">No calendar named foorbar could be found</'
-            in output.data)
+        output_text = output.get_data(as_text=True)
+        self.assertIn(
+            'class="errors">No calendar named foorbar could be found</',
+            output_text)
 
         today = date.today()
         output = self.app.get('/list/test_calendar/%s/%s/%s/' % (
             today.year, today.month, today.day))
         self.assertEqual(output.status_code, 200)
-        self.assertTrue(
-            '<title>test_calendar - Fedocal</title>' in output.data)
-        self.assertTrue(' <a href="/test_calendar/">' in output.data)
-        self.assertTrue(' <a href="/test_calendar2/">' in output.data)
-        self.assertTrue(' <a href="/test_calendar4/">' in output.data)
+        output_text = output.get_data(as_text=True)
+        self.assertIn(
+            '<title>test_calendar - Fedocal</title>', output_text)
+        self.assertIn(' <a href="/test_calendar/">', output_text)
+        self.assertIn(' <a href="/test_calendar2/">', output_text)
+        self.assertIn(' <a href="/test_calendar4/">', output_text)
 
         output = self.app.get('/list/test_calendar/%s/%s/%s' % (
             today.year, today.month, today.day))
@@ -241,69 +255,74 @@ class Flasktests(Modeltests):
         output = self.app.get('/list/test_calendar/%s/%s/%s/' % (
             today.year, today.month, today.day), follow_redirects=True)
         self.assertEqual(output.status_code, 200)
-        self.assertTrue(
-            '<title>test_calendar - Fedocal</title>' in output.data)
-        self.assertTrue(' <a href="/test_calendar/">' in output.data)
-        self.assertTrue(' <a href="/test_calendar2/">' in output.data)
-        self.assertTrue(' <a href="/test_calendar4/">' in output.data)
+        output_text = output.get_data(as_text=True)
+        self.assertIn(
+            '<title>test_calendar - Fedocal</title>', output_text)
+        self.assertIn(' <a href="/test_calendar/">', output_text)
+        self.assertIn(' <a href="/test_calendar2/">', output_text)
+        self.assertIn(' <a href="/test_calendar4/">', output_text)
 
         output = self.app.get('/list/test_calendar/%s/%s/' % (
             today.year, today.month), follow_redirects=True)
         self.assertEqual(output.status_code, 200)
+        output_text = output.get_data(as_text=True)
         # 6 on Tue Jun 24 - 12 before, 14 on Tue Jul 15
-        self.assertTrue(output.data.count('<a class="event meeting_') >= 5)
-        self.assertTrue(output.data.count('<tr') > 10)
-        self.assertTrue(
-            '<title>test_calendar - Fedocal</title>' in output.data)
-        self.assertTrue(' <a href="/test_calendar/">' in output.data)
-        self.assertTrue(' <a href="/test_calendar2/">' in output.data)
-        self.assertTrue(' <a href="/test_calendar4/">' in output.data)
+        self.assertTrue(output_text.count('<a class="event meeting_') >= 5)
+        self.assertTrue(output_text.count('<tr') > 10)
+        self.assertIn(
+            '<title>test_calendar - Fedocal</title>', output_text)
+        self.assertIn(' <a href="/test_calendar/">', output_text)
+        self.assertIn(' <a href="/test_calendar2/">', output_text)
+        self.assertIn(' <a href="/test_calendar4/">', output_text)
 
         output = self.app.get('/list/test_calendar/%s/%s/?subject=Another'
             % (today.year, today.month), follow_redirects=True)
         self.assertEqual(output.status_code, 200)
+        output_text = output.get_data(as_text=True)
         # 4 on Tue Jun 24 - 6 before, 8 on Tue Jul 15
-        self.assertTrue(output.data.count('<a class="event meeting_') >= 4)
-        self.assertTrue(output.data.count('<tr') > 10)
-        self.assertTrue(
-            '<title>test_calendar - Fedocal</title>' in output.data)
-        self.assertTrue(' <a href="/test_calendar/">' in output.data)
-        self.assertTrue(' <a href="/test_calendar2/">' in output.data)
-        self.assertTrue(' <a href="/test_calendar4/">' in output.data)
+        self.assertTrue(output_text.count('<a class="event meeting_') >= 4)
+        self.assertTrue(output_text.count('<tr') > 10)
+        self.assertIn(
+            '<title>test_calendar - Fedocal</title>', output_text)
+        self.assertIn(' <a href="/test_calendar/">', output_text)
+        self.assertIn(' <a href="/test_calendar2/">', output_text)
+        self.assertIn(' <a href="/test_calendar4/">', output_text)
 
         output = self.app.get('/list/test_calendar/%s/%s/?subject=Another past'
             % (today.year, today.month), follow_redirects=True)
         self.assertEqual(output.status_code, 200)
-        self.assertEqual(output.status_code, 200)
+        output_text = output.get_data(as_text=True)
         # 3 on Tue Jun 24 - 4 before, 5 on Tue Jul 15
-        self.assertTrue(output.data.count('<a class="event meeting_') >= 3)
-        self.assertTrue(output.data.count('<tr') >= 10)
-        self.assertTrue(
-            '<title>test_calendar - Fedocal</title>' in output.data)
-        self.assertTrue(' <a href="/test_calendar/">' in output.data)
-        self.assertTrue(' <a href="/test_calendar2/">' in output.data)
-        self.assertTrue(' <a href="/test_calendar4/">' in output.data)
+        self.assertTrue(output_text.count('<a class="event meeting_') >= 3)
+        self.assertTrue(output_text.count('<tr') >= 10)
+        self.assertIn(
+            '<title>test_calendar - Fedocal</title>', output_text)
+        self.assertIn(' <a href="/test_calendar/">', output_text)
+        self.assertIn(' <a href="/test_calendar2/">', output_text)
+        self.assertIn(' <a href="/test_calendar4/">', output_text)
 
         output = self.app.get('/list/test_calendar/%s/%s/?delta=10'
             % (today.year, today.month), follow_redirects=True)
         self.assertEqual(output.status_code, 200)
+        output_text = output.get_data(as_text=True)
         # 1 on Tue Jun 24 - 2 before
         self.assertTrue(
-            output.data.count(
+            output_text.count(
                 '<a class="event event_blue meeting_') in range(9))
-        self.assertTrue(output.data.count('<tr') >= 6)
-        self.assertTrue(
-            '<title>test_calendar - Fedocal</title>' in output.data)
+        self.assertTrue(output_text.count('<tr') >= 6)
+        self.assertIn(
+            '<title>test_calendar - Fedocal</title>', output_text)
 
         output = self.app.get('/list/test_calendar/%s/%s/?delta=abc'
             % (today.year, today.month), follow_redirects=True)
         self.assertEqual(output.status_code, 200)
+        output_text = output.get_data(as_text=True)
         # 6 on Tue Jun 24 - 12 before, 14 on Tue Jul 15
-        self.assertTrue(output.data.count(
+        self.assertTrue(output_text.count(
             '<a class="event event_blue meeting_') >= 5)
-        self.assertTrue(output.data.count('<tr') >= 10)
-        self.assertTrue(
-            '<title>test_calendar - Fedocal</title>' in output.data)
+        self.assertTrue(output_text.count('<tr') >= 10)
+        self.assertIn(
+            '<title>test_calendar - Fedocal</title>', output_text)
 
         end_date = today + timedelta(days=10)
 
@@ -311,24 +330,26 @@ class Flasktests(Modeltests):
             % (today.year, today.month, end_date.strftime('%Y-%m')
             ), follow_redirects=True)
         self.assertEqual(output.status_code, 200)
+        output_text = output.get_data(as_text=True)
         # 14 on Tue Jun 24 - 2 before, 1 on August 15th
-        self.assertTrue(output.data.count(
+        self.assertTrue(output_text.count(
             '<a class="event event_blue meeting_') > 0)
         # 22 on Tue Jun 24 - 10 before, 8 on August 15th
-        self.assertTrue(output.data.count('<tr') >= 7)
-        self.assertTrue(
-            '<title>test_calendar - Fedocal</title>' in output.data)
+        self.assertTrue(output_text.count('<tr') >= 7)
+        self.assertIn(
+            '<title>test_calendar - Fedocal</title>', output_text)
 
         output = self.app.get('/list/test_calendar/%s/%s/?end=foobar'
             % (today.year, today.month), follow_redirects=True)
         self.assertEqual(output.status_code, 200)
+        output_text = output.get_data(as_text=True)
         # 6 on Tue Jun 24 - 12 before, 14 on Tue Jul 15
-        self.assertTrue(output.data.count('<a class="event meeting_') >= 5)
+        self.assertTrue(output_text.count('<a class="event meeting_') >= 5)
         # 14 on Tue Jun 24 - 20 before, 21 on Tue Jul 15, 27 on Fri Aug 1
         # 22 on August 15th
-        self.assertTrue(output.data.count('<tr') >= 12)
-        self.assertTrue(
-            '<title>test_calendar - Fedocal</title>' in output.data)
+        self.assertTrue(output_text.count('<tr') >= 12)
+        self.assertIn(
+            '<title>test_calendar - Fedocal</title>', output_text)
 
     def test_ical_out(self):
         """ Test the ical_out function. """
@@ -336,14 +357,15 @@ class Flasktests(Modeltests):
 
         output = self.app.get('/ical/test_calendar/')
         self.assertEqual(output.status_code, 200)
-        self.assertTrue('BEGIN:VCALENDAR' in output.data)
-        self.assertTrue('SUMMARY:test-meeting2' in output.data)
-        self.assertTrue(
-            'DESCRIPTION:This is a test meeting with recursion'
-            in output.data)
-        self.assertTrue('ORGANIZER:pingou' in output.data)
-        self.assertEqual(output.data.count('BEGIN:VEVENT'), 10)
-        self.assertEqual(output.data.count('END:VEVENT'), 10)
+        output_text = output.get_data(as_text=True)
+        self.assertIn('BEGIN:VCALENDAR', output_text)
+        self.assertIn('SUMMARY:test-meeting2', output_text)
+        self.assertIn(
+            'DESCRIPTION:This is a test meeting with recursion',
+            output_text)
+        self.assertIn('ORGANIZER:pingou', output_text)
+        self.assertEqual(output_text.count('BEGIN:VEVENT'), 10)
+        self.assertEqual(output_text.count('END:VEVENT'), 10)
 
         output = self.app.get('/ical/foorbar/')
         self.assertEqual(output.status_code, 404)
@@ -354,44 +376,48 @@ class Flasktests(Modeltests):
 
         output = self.app.get('/location/list/EMEA/')
         self.assertEqual(output.status_code, 200)
-        self.assertTrue(
-            '<title> EMEA  - Fedocal</title>' in output.data)
-        self.assertTrue(' <a href="/test_calendar/">' in output.data)
-        self.assertTrue(' <a href="/test_calendar2/">' in output.data)
-        self.assertTrue(' <a href="/test_calendar4/">' in output.data)
-        self.assertEqual(output.data.count('<a class="event event_blue'), 2)
-        self.assertEqual(output.data.count('<a class="event'), 4)
+        output_text = output.get_data(as_text=True)
+        self.assertIn(
+            '<title> EMEA  - Fedocal</title>', output_text)
+        self.assertIn(' <a href="/test_calendar/">', output_text)
+        self.assertIn(' <a href="/test_calendar2/">', output_text)
+        self.assertIn(' <a href="/test_calendar4/">', output_text)
+        self.assertEqual(output_text.count('<a class="event event_blue'), 1)
+        self.assertEqual(output_text.count('<a class="event'), 2)
 
         output = self.app.get('/location/list/foorbar/', follow_redirects=True)
         self.assertEqual(output.status_code, 200)
-        self.assertTrue(
-            'class="errors">No location named foorbar could be found</'
-            in output.data)
+        output_text = output.get_data(as_text=True)
+        self.assertIn(
+            'class="errors">No location named foorbar could be found</',
+            output_text)
 
         today = date.today()
         output = self.app.get('/location/list/EMEA/%s/%s/%s/' % (
             today.year, today.month, today.day))
         self.assertEqual(output.status_code, 200)
-        self.assertTrue(
-            '<title> EMEA  - Fedocal</title>' in output.data)
-        self.assertTrue(' <a href="/test_calendar/">' in output.data)
-        self.assertTrue(' <a href="/test_calendar2/">' in output.data)
-        self.assertTrue(' <a href="/test_calendar4/">' in output.data)
-        self.assertTrue(
-            output.data.count('<a class="event event_blue') in [0, 1])
-        self.assertTrue(output.data.count('<a class="event') in range(3))
+        output_text = output.get_data(as_text=True)
+        self.assertIn(
+            '<title> EMEA  - Fedocal</title>', output_text)
+        self.assertIn(' <a href="/test_calendar/">', output_text)
+        self.assertIn(' <a href="/test_calendar2/">', output_text)
+        self.assertIn(' <a href="/test_calendar4/">', output_text)
+        self.assertIn(
+            output_text.count('<a class="event event_blue'), [0, 1])
+        self.assertIn(output_text.count('<a class="event'), range(3))
 
         output = self.app.get('/location/list/EMEA/%s/%s/' % (
             today.year, today.month))
         self.assertEqual(output.status_code, 200)
-        self.assertTrue(
-            '<title> EMEA  - Fedocal</title>' in output.data)
-        self.assertTrue(' <a href="/test_calendar/">' in output.data)
-        self.assertTrue(' <a href="/test_calendar2/">' in output.data)
-        self.assertTrue(' <a href="/test_calendar4/">' in output.data)
-        self.assertTrue(
-            output.data.count('<a class="event event_blue') in [1, 2])
-        self.assertTrue(output.data.count('<a class="event') in [2, 4])
+        output_text = output.get_data(as_text=True)
+        self.assertIn(
+            '<title> EMEA  - Fedocal</title>', output_text)
+        self.assertIn(' <a href="/test_calendar/">', output_text)
+        self.assertIn(' <a href="/test_calendar2/">', output_text)
+        self.assertIn(' <a href="/test_calendar4/">', output_text)
+        self.assertIn(
+            output_text.count('<a class="event event_blue'), [1, 2])
+        self.assertIn(output_text.count('<a class="event'), [2, 4])
 
     def test_ical_all(self):
         """ Test the ical_all function. """
@@ -399,14 +425,15 @@ class Flasktests(Modeltests):
 
         output = self.app.get('/ical/')
         self.assertEqual(output.status_code, 200)
-        self.assertTrue('BEGIN:VCALENDAR' in output.data)
-        self.assertTrue('SUMMARY:test-meeting2' in output.data)
-        self.assertTrue(
-            'DESCRIPTION:This is a test meeting with recursion'
-            in output.data)
-        self.assertTrue('ORGANIZER:pingou' in output.data)
-        self.assertEqual(output.data.count('BEGIN:VEVENT'), 15)
-        self.assertEqual(output.data.count('END:VEVENT'), 15)
+        output_text = output.get_data(as_text=True)
+        self.assertIn('BEGIN:VCALENDAR', output_text)
+        self.assertIn('SUMMARY:test-meeting2', output_text)
+        self.assertIn(
+            'DESCRIPTION:This is a test meeting with recursion',
+            output_text)
+        self.assertIn('ORGANIZER:pingou', output_text)
+        self.assertEqual(output_text.count('BEGIN:VEVENT'), 15)
+        self.assertEqual(output_text.count('END:VEVENT'), 15)
 
     def test_ical_meeting(self):
         """ Test the ical_calendar_meeting function. """
@@ -427,11 +454,22 @@ class Flasktests(Modeltests):
 
         output = self.app.get('/ical/calendar/meeting/2/')
         self.assertEqual(output.status_code, 200)
+        output_text = output.get_data(as_text=True)
         data = self.wrap_content(
-            output.data, replacements=[
-                (r'UID:.*\n', 'UID:DUMMY_UID\r\n')
+            output_text, replacements=[
+                (r'UID:.*\n', 'UID:DUMMY_UID\r\n'),
+                (r'DTSTAMP:.*\n', 'DTSTAMP:20181221T120122Z\r\n'),
             ]
         )
+        # Newer python-vobject in the DTSTAMP field
+        if "DTSTAMP" in data:
+            string = "DTSTAMP:20181221T120122Z\r\nORGANIZER"
+            if six.PY3:
+                string = "DTSTAMP:20181221T120122Z\nORGANIZER"
+            expected_data = expected_data.replace("ORGANIZER", string)
+
+        if six.PY3:
+            data = data.replace("\r\n", "\n")
         self.assertEqual(data, expected_data)
 
         # Test meeting iCal with reminder
@@ -448,24 +486,37 @@ class Flasktests(Modeltests):
         )
         output = self.app.get('/ical/calendar/meeting/2/?reminder_delta=60')
         self.assertEqual(output.status_code, 200)
+        output_text = output.get_data(as_text=True)
         data = self.wrap_content(
-            output.data, replacements=[
-                (r'UID:.*\n', 'UID:DUMMY_UID\r\n')
+            output_text, replacements=[
+                (r'UID:.*\n', 'UID:DUMMY_UID\r\n'),
+                (r'DTSTAMP:.*\n', 'DTSTAMP:20181221T120122Z\r\n'),
             ]
         )
+        # Newer python-vobject in the DTSTAMP field
+        if "DTSTAMP" in data:
+            string = "DTSTAMP:20181221T120122Z\r\nORGANIZER"
+            if six.PY3:
+                string = "DTSTAMP:20181221T120122Z\nORGANIZER"
+            expected_data = expected_data.replace("ORGANIZER", string)
+
+        if six.PY3:
+            data = data.replace("\r\n", "\n")
         self.assertEqual(data, expected_data)
 
         # Test non numeric value for numeric data
         output = self.app.get('/ical/calendar/meeting/2/?reminder_delta=foo')
         self.assertEqual(output.status_code, 200)
-        self.assertFalse('VALARM' in output.data)
+        output_text = output.get_data(as_text=True)
+        self.assertNotIn('VALARM', output_text)
         self.assertEqual(data, expected_data)
 
         # Test with a reminder_delta value not in the default choice
         output = self.app.get('/ical/calendar/meeting/2/?reminder_delta=150')
         self.assertEqual(output.status_code, 200)
-        self.assertTrue('VALARM' in output.data)
-        self.assertTrue('TRIGGER:-PT2H30M' in output.data)
+        output_text = output.get_data(as_text=True)
+        self.assertIn('VALARM', output_text)
+        self.assertIn('TRIGGER:-PT2H30M', output_text)
 
     def test_view_meeting(self):
         """ Test the view_meeting function. """
@@ -473,19 +524,20 @@ class Flasktests(Modeltests):
 
         output = self.app.get('/meeting/5/')
         self.assertEqual(output.status_code, 200)
-        self.assertTrue(
-            '<title>Meeting "test-meeting-st-1" - Fedocal</title>'
-            in output.data)
-        self.assertTrue(
-            '<h2 class="orange">Meeting "test-meeting-st-1"</h2>'
-            in output.data)
-        self.assertTrue(
-            'This is a test meeting at the same time'
-            in output.data)
-        self.assertTrue('iCal export' in output.data)
-        self.assertTrue(
-            '<select id="ical-meeting-export-reminder-at"'
-            in output.data)
+        output_text = output.get_data(as_text=True)
+        self.assertIn(
+            '<title>Meeting "test-meeting-st-1" - Fedocal</title>',
+            output_text)
+        self.assertIn(
+            '<h2 class="orange">Meeting "test-meeting-st-1"</h2>',
+            output_text)
+        self.assertIn(
+            'This is a test meeting at the same time',
+            output_text)
+        self.assertIn('iCal export', output_text)
+        self.assertIn(
+            '<select id="ical-meeting-export-reminder-at"',
+            output_text)
 
     def test_view_meeting_page(self):
         """ Test the view_meeting_page function. """
